Imports Syncfusion.Windows.Forms.Grid
Imports System.Runtime.InteropServices

Namespace SampleDataBoundGrid
    Public Class AADataBoundGrid
        '******************************************************************
        'Description....Customized SyncFusion grid to persist expanded state
        '               during sort
        '
        'Date           Modified By         Description
        '------------------------------------------------------------------
        '07/23/2003     A. Bhatnagar        Initial Revision.
        '08/14/2003     A. Bhatnagar        Added SyncFusion code to allow freeze 
        '                                   of painting
        '******************************************************************    
        Inherits GridDataBoundGrid

        Public Delegate Sub SortColumnHandler(ByVal colIndex As Integer, ByRef theGrid As GridDataBoundGrid, ByVal sortStep As Integer)
        Dim sortColumnAddress As SortColumnHandler = Nothing

        Public Sub setColumnSortHandler(ByRef sortColAddr As SortColumnHandler)
            sortColumnAddress = sortColAddr
        End Sub

        Public Overrides Sub SortColumn(ByVal colIndex As Integer)
            If (Not sortColumnAddress Is Nothing) Then
                Try
                    sortColumnAddress(colIndex, Me, 0)
                Catch objException As Exception
                    Throw objException
                End Try
            End If

            MyBase.SortColumn(colIndex)
            If (Not sortColumnAddress Is Nothing) Then
                Try
                    sortColumnAddress(colIndex, Me, 1)
                Catch objException As Exception
                    Throw objException
                End Try
            End If
        End Sub

#Region "Code to Freeze System Painting for this grid"
        'Syncfusion code
        ' see Syncfusions Windows Forms FAQ entry entitled:
        ' Is there a way to halt a screen from painting until all the controls on the form are initialized?
        ' http://www.syncfusion.com/faq/winforms/search/637.asp

        <DllImport("User32", CharSet:=0, SetLastError:=False, ExactSpelling:=False, PreserveSig:=False, CallingConvention:=CallingConvention.Winapi)> _
            Private Shared Function SendMessage(ByVal hWnd As System.IntPtr, ByVal msg As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Boolean
        End Function

        Private Const WM_SETREDRAW As Integer = 11
        Private paintFrozen As Integer

        Property FreezePainting() As Boolean
            Get
                Return (paintFrozen > 0)
            End Get
            Set(ByVal Value As Boolean)

                If ((Value AndAlso IsHandleCreated) _
                            AndAlso Me.Visible) Then
                    If (0 = paintFrozen) Then
                        paintFrozen = paintFrozen + 1
                        SendMessage(Handle, WM_SETREDRAW, 0, 0)
                    Else
                        paintFrozen = paintFrozen + 1
                    End If
                End If
                If Not (Value) Then
                    If (paintFrozen = 0) Then
                        Return
                    End If
                    paintFrozen = paintFrozen - 1
                    If 0 = paintFrozen Then
                        SendMessage(Handle, WM_SETREDRAW, 1, 0)
                        Invalidate(True)
                    End If
                End If

            End Set
        End Property
#End Region
    End Class

End Namespace
